<?php

/**
 * @Module Name: 1Pay Payments | WHMCS
 * Plugin URI: http://1pay.in
 * Description: Extends WHMCS with 1Pay services
 * Version: 1.0.3
 * @author: Soumil Gada, Manisha Gupta
 * Author EMAIL: soumil.gada@mobilewaretech.com
 * @copyright: @2018 Mobilewaretech. All rights reserved
 */
include("Functions.php");
if (!defined("WHMCS")) {
    die("This file cannot be accessed directly");
}

function onepay_MetaData() {
    return array(
        'DisplayName' => 'OnePay Payment Gateway',
        'APIVersion' => '1.0',
        'DisableLocalCredtCardInput' => true,
        'TokenisedStorage' => false,
    );
}

function onepay_config() {
    $configarray = array(
        "FriendlyName" => array("Type" => "System", "Value" => "OnePay Payment Gateway"),
        "mode" => array("FriendlyName" => "Gateway Mode", "Type" => "dropdown", "Options" => "Sandbox,Production",),
        "merchant_id" => array("FriendlyName" => "Merchant ID", "Type" => "text", "Size" => "50",),
        "api_key" => array("FriendlyName" => "Working Key", "Type" => "text", "Size" => "50",),
    );
    return $configarray;
}

function onepay_link($params) {
    $gatewaymerchant_id = $params['merchant_id'];
    $gatewayworkingkey = $params['api_key'];
    $gatewaymode = $params['mode'];

    $firstname = $params['clientdetails']['firstname'];
    $lastname = $params['clientdetails']['lastname'];
    $address1 = $params['clientdetails']['address1'];
    $address2 = $params['clientdetails']['address2'];
    $city = $params['clientdetails']['city'];
    $state = $params['clientdetails']['state'];
    $postcode = $params['clientdetails']['postcode'];
    $country = $params['clientdetails']['country'];

    $invoiceid = $params['invoiceid'];
    $description = $params["description"];
    $amount = $params['amount']; # Format: ##.##
    $currency = "INR"; # Currency Code
    $email = $params['clientdetails']['email'];
    $mobileno = $params['clientdetails']['phonenumber'];
    $datetime = date('Y-m-d h:i:s');
    $txntype = "DIRECT";

    $url = "https://pay.1paypg.in/payone/";
    if ($gatewaymode === "Sandbox") {
        $url = "http://139.59.1.254:8080/onepayVAS/";
    }

    $txnId = $invoiceid . time();

    $postVariables = array(
        "merchantId" => $gatewaymerchant_id,
        "apiKey" => $gatewayworkingkey,
        "txnId" => $txnId,
        "dateTime" => $datetime,
        "amount" => $amount,
        "custMobile" => $mobileno,
        "custMail" => $email,
        "url" => $url,
        "channelId" => '0',
        "txnType" => 'DIRECT',
        "instrumentId" => '0',
        "bankId" => 'NA',
        "productId" => 'DEFAULT',
        "isMultiSettlement" => "0",
        "cardType" => "NA",
        "udf1" => "NA",
        "udf2" => "NA",
        "udf3" => "NA",
        'cardDetails' => 'NA',
        'udf4' => 'NA',
        'udf5' => 'NA',
        "returnURL" => $params['systemurl'] . "/modules/gateways/callback/onepay.php"
    );
    $functions = new Functions();
    $postVariables['checksum'] = $functions->checksum($postVariables);

    $jsondata = json_encode($postVariables);
    $enc = $functions->get_encrypt($jsondata);



    # System Variables
    $companyname = $params['companyname'];
    $systemurl = $params['systemurl'];
    $currency = "INR";
    $sucUrl = '';
    //eg:"/modules/gateways/callback/success.php"
    $failUrl = '';
    //eg:"/modules/gateways/callback/failure.php"

    $code = '<html><head><title>Redirection</title></head><body><div style="margin: auto; text-align: center;">';
    $code .= '<form action="' . $url . 'payprocessor" method="post" name="frmOnePay" >';
    $code .= '<input type="text" name="merchantId" value="' . $this->merchantid . '">';
    $code .= '<input type="text" name="reqData" value="' . $enc . '">';
 
    $code .= '<input type="submit" value="Pay Now" />';

    $code .= '</form></div>';
    return $code;
}

?>